<?PHP
/*
 * EasyNav 
 * written by Christian Heilmann (http://icant.co.uk)
 * Autmatically highlights the current page in a navigation 
 * template and gets rid of all but the current nested 
 * navigations.
 * The template must me a well-formed nested list!
 */

/* Variables */

// id added to the current LI
	$listitem_id='active'; 	
// id added to the current A
	$link_id='current'; 	
// navigation file
	$nav='nav.html';		

/* Variables dependent on DOMXML availability */

// class added to each LI containing the current one and the "parent" link
	$parentclass='parent';	
// ID to remove non-active sub navigations
	$rsnID='navrsn';		
// ID to remove non-active sub navigations and show the current sub navigation first
	$rsncnoID='navrsncno';	 
// ID to remove non-active sub navigations and show the current sub navigation
// after the home link
	$rsncnonhomeID='navrsncnohome';
// ID to show the current sub navigation after the home link
	$cnonhomeID='navcnohome';
// ID to show the current sub navigation first
	$cnoID='navcno';

/* Don't touch!*/
	$self=$_SERVER['PHP_SELF'];
	$handle = @fopen($nav, "r");
	$contents = @fread($handle, filesize($nav));
	@fclose($handle);
	if($handle==''){die('No navigation found.');}

/* PHP Versions without DOMXML */
	preg_match_all('/(<a.*?href="(.*?)">(.*?)<\/a>)/si',$contents,$as);
	for($i=0;$i<sizeof($as[0]);$i++)
	{
		if(preg_match('/\/'.$as[2][$i].'/',$self))
		{
			$found=$as[0][$i];
			$foundname=$as[3][$i];
			break;
		}
	}
	if($found)
	{
		$contents=preg_replace('/'.preg_replace('/\//','\/',$found).'/','<strong>'.$foundname.'</strong>',$contents);
	}
	if (!function_exists('domxml_xmltree')) 
	{
		echo preg_replace('/<li(.*?)>(.*?)<strong>/','<li\\1 id="'.$listitem_id.'">\\2<strong id="'.$link_id.'">',$contents);
		exit();
	}
/* DOMXML enabled PHP */
	if (function_exists('domxml_xmltree')) 
	{
		$htmldoc = domxml_xmltree($contents);
		$ul = $htmldoc->document_element();
		$rsn=false;				
		$cno=false;				
		$stickyhome=false;		
		switch($ul->get_attribute('id'))
		{
			case $rsnID:
				$rsn=true;				
				$cno=false;				
				$stickyhome=false;		
			break;
			case $rsncnoID:
				$rsn=true;				
				$cno=true;				
				$stickyhome=false;		
			break;
			case $rsncnonhomeID:
				$rsn=true;				
				$cno=true;				
				$stickyhome=true;		
			break;
			case $cnoID:
				$rsn=false;				
				$cno=true;				
				$stickyhome=false;		
			break;
			case $cnonhomeID:
				$rsn=false;				
				$cno=true;				
				$stickyhome=true;		
			break;
		}
		$hl = $htmldoc->get_elements_by_tagname("strong");
		if($hl[0])
		{
			$mother=$hl[0]->parent_node();
			$hl[0]->set_attribute('id',$link_id);
			$mother->set_attribute('id',$listitem_id);
		}
		$uls = $htmldoc->get_elements_by_tagname("ul");
		foreach($uls as $i)
		{
			$mother=$i->parent_node();
			if($mother->node_name()=='li')
			{	
				if(sizeof($mother->get_elements_by_tagname("strong"))==0)
				{
					if($rsn){$mother->remove_child($i);}
				} else {
					$l=$mother->get_elements_by_tagname("a");
					if($mother->get_attribute('id')!=$listitem_id)
					{
						$l[0]->set_attribute('class',$parentclass);
						$mother->set_attribute('class',$parentclass);
					}
				} 
			}
		}

/* Contextual navigation order (CNO) */	
		if($cno)
		{
			$lis=$htmldoc->get_elements_by_tagname('li');
			$ishome=true;
			foreach($lis as $l)
			{
				if(sizeof($l->get_elements_by_tagname("strong"))!=0)
				{
					if($ishome && $l==$lis[0]){break;}
					$clone=$l->clone_node(true);
					$mother=$l->parent_node();
					$mother->remove_child($l);
					$ishome=false;
					break;
				}
			}
			if(!$ishome)
			{
				$lis=$htmldoc->get_elements_by_tagname('li');
				$rep=$stickyhome?$lis[1]:$lis[0];
				$htmldoc->insert_before($clone,$rep);
			}
		}
/* end CNO */

		echo $htmldoc->html_dump_mem();
	} 
?>